from __future__ import print_function
import sys

V3K = False  #: Python3.5+
if sys.version_info[:2] > (3, 4,):
    V3K = True
    unicode = str  # @ReservedAssignment
elif sys.version_info[:1] > (2,):
    raise Exception("Python3 requires 3.5+")

print()
print(sys.version_info)
print()

mystring = "abc"
u0 = unicode(mystring)  # == str(mystring)
print()
print("case-00")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = r"abc"
u0 = unicode(mystring)  # == str(mystring)
print()
print("case-01")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = u"abc"
u0 = unicode(mystring)  # == str(mystring)
print()
print("case-02")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = "abc"
u0 = unicode(bytes(mystring.encode('ascii')), 'ascii')  # == str(mystring)
print()
print("case-03")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = "abc"
u0 = unicode(bytes(mystring.encode('utf-8')), 'ascii')  # == str(mystring)
print()
print("case-04")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = "abc"
u0 = unicode(bytes(mystring.encode()))  # == str(mystring)
print()
print("case-05")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = "abc"
u0 = unicode(bytes(mystring.encode('utf-8')))  # == str(mystring)
print()
print("case-06")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = "abc"
u0 = unicode(bytes(mystring.encode('ascii')))  # == str(mystring)
print()
print("case-07")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)

mystring = b"abc"
u0 = unicode(mystring)  # == str(mystring)
print()
print("case-08")
print("type: " + str(type(u0)))
print("len:  " + str(len(u0)))
print(u0)
